from PyQt4 import QtGui, QtCore

words = [
    {'name' : 'day',
     'opposite' : 'night'
     },
    {'name' : 'sunny',
     'opposite' : 'rainy'
     }
    ]

class MyModel(QtCore.QAbstractItemModel):
    def __init__(self, parent = None):
        QtCore.QAbstractItemModel.__init__(self, parent)
        self.cache = {}

    def index(self, row, column, parent = None):
        if row < 0 or column < 0 or row >= self.rowCount(parent) or column >= self.columnCount(parent):
            return QtCore.QModelIndex()

        return QtCore.QAbstractItemModel.createIndex(self, row, column);

    def parent(self, index):
        return QtCore.QModelIndex()

    def rowCount(self, parent):
        if not parent.isValid():
            return len(words)
        else:
            return 0

    def columnCount(self, parent):
        return 2

    def data(self, index, role):
        if index.isValid() == 0:
            return QtCore.QVariant();

        if index.column() > 1:
            return QtCore.QVariant();

        if index.row() > len(words) - 1:
            return QtCore.QVariant();

        if role == QtCore.Qt.DisplayRole or role == QtCore.Qt.EditRole:
            if index.column() == 0:
                return QtCore.QVariant(words[index.row()]['name'])
            else:
                return QtCore.QVariant(words[index.row()]['opposite'])
        else:
            return QtCore.QVariant()
